public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Sam James" <sam@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: games-strategy/0ad/
Date: Sun, 15 Aug 2021 20:57:08 +0000 (UTC)	[thread overview]
Message-ID: <1629061016.57cc262249976487a77241a6641f6c9437072b69.sam@gentoo> (raw)

commit:     57cc262249976487a77241a6641f6c9437072b69
Author:     Nils Freydank <holgersson <AT> posteo <DOT> de>
AuthorDate: Thu Aug 12 07:25:00 2021 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Sun Aug 15 20:56:56 2021 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=57cc2622

games-strategy/0ad: Bump to 0.0.25_alpha, unbundle premake

This bump unbundles premake and uses now dev-util/premake:5::gentoo.
Drop the ~arm64 keyword until premake get's ~arm64 keywords.

Upstream spidermonkey keeps changing critical stuff on minor releases, so
this bump keeps the the bundled version.

On the fly we can do some house-keeping inside the ebuild:
- add size checks as the package size got huge by the 0ad-data merge
- merge conditional blocks depending on the version into one block
  for better maintainability
- sort LICENSE alphabetically

Closes: https://bugs.gentoo.org/807337
Package-Manager: Portage-3.0.20, Repoman-3.0.3
Signed-off-by: Nils Freydank <holgersson <AT> posteo.de>
Signed-off-by: Sam James <sam <AT> gentoo.org>

 games-strategy/0ad/0ad-0.0.25_alpha.ebuild | 221 +++++++++++++++++++++++++++++
 games-strategy/0ad/Manifest                |   2 +
 2 files changed, 223 insertions(+)

diff --git a/games-strategy/0ad/0ad-0.0.25_alpha.ebuild b/games-strategy/0ad/0ad-0.0.25_alpha.ebuild
new file mode 100644
index 00000000000..c4b1cf74eb7
--- /dev/null
+++ b/games-strategy/0ad/0ad-0.0.25_alpha.ebuild
@@ -0,0 +1,221 @@
+# Copyright 2014-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+WX_GTK_VER="3.0-gtk3"
+PYTHON_COMPAT=( python3_{7..9} )
+inherit desktop toolchain-funcs multiprocessing python-any-r1 wxwidgets xdg
+
+if [[ ${PV} == 9999 ]]; then
+	inherit git-r3
+	EGIT_REPO_URI="https://github.com/0ad/0ad"
+	S="${WORKDIR}/${P}"
+elif [[ ${PV} == *_pre* ]]; then
+	ZEROAD_GIT_REVISION="c7d07d3979f969b969211a5e5748fa775f6768a7"
+	SRC_URI="https://github.com/0ad/0ad/archive/${ZEROAD_GIT_REVISION}.tar.gz -> ${P}.tar.gz"
+	S="${WORKDIR}/${PN}-${ZEROAD_GIT_REVISION}"
+else
+	MY_P="0ad-${PV/_/-}"
+	SRC_URI="
+		http://releases.wildfiregames.com/${MY_P}-unix-build.tar.xz
+		https://releases.wildfiregames.com/${MY_P}-unix-data.tar.xz
+	"
+	S="${WORKDIR}/${MY_P}"
+fi
+
+DESCRIPTION="A free, real-time strategy game"
+HOMEPAGE="https://play0ad.com/"
+LICENSE="BitstreamVera CC-BY-SA-3.0 GPL-2 LGPL-2.1 LPPL-1.3c MIT ZLIB"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE="editor +lobby nvtt pch test"
+RESTRICT="test"
+CHECKREQS_DISK_BUILD="9000M" # 8779624 KiB (8.3 GiB)
+CHECKREQS_DISK_USR="3500M" # 3545840 KiB (3.3 GiB)
+# Premake adds '-s' to some LDFLAGS. Simply sed'ing it out leads to
+# build and/or startup issues.
+QA_PRESTRIPPED="/usr/lib64/0ad/libCollada.so /usr/bin/0ad"
+
+# virtual/rust is for bundled SpiderMonkey
+# Build-time Python dependency is for SM, too.
+# TODO: Unbundle premake5
+# See bug #773472 which may help (bump for it)
+BDEPEND="
+	${PYTHON_DEPS}
+	>=dev-util/premake-5.0.0_alpha12:5
+	virtual/pkgconfig
+	virtual/rust
+	test? ( dev-lang/perl )
+"
+# Removed dependency on nvtt as we use the bundled one
+# bug #768930
+DEPEND="
+	dev-libs/boost:=
+	dev-libs/icu:=
+	dev-libs/libfmt:0=
+	dev-libs/libsodium
+	dev-libs/libxml2
+	media-libs/libpng:0
+	media-libs/libsdl2[X,opengl,video]
+	media-libs/libvorbis
+	media-libs/openal
+	net-libs/enet:1.3
+	net-libs/miniupnpc:=
+	net-misc/curl
+	sys-libs/zlib
+	virtual/opengl
+	x11-libs/libX11
+	editor? ( x11-libs/wxGTK:${WX_GTK_VER}[X,opengl] )
+	lobby? ( net-libs/gloox )
+"
+RDEPEND="
+	${DEPEND}
+	!games-strategy/0ad-data
+"
+
+PATCHES=(
+	"${FILESDIR}"/${PN}-0.0.24b_alpha-respect-tc.patch
+)
+
+pkg_setup() {
+	use editor && setup-wxwidgets
+}
+
+src_prepare() {
+	default
+
+	# SpiderMonkey's configure no longer recognises --build for
+	# the build tuple
+	sed -i -e "/--build/d" libraries/source/spidermonkey/build.sh || die
+
+	# Originally from 0ad-data
+	rm binaries/data/tools/fontbuilder/fonts/*.txt || die
+}
+
+src_configure() {
+	# 0AD uses premake:5 to generate the Makefiles, so let's
+	# 1. configure the configure args,
+	# 2. export some toolchain args,
+	# 3. configure premake args,
+	# 4. run premake5.
+	local myconf=(
+		--minimal-flags
+		$(usex nvtt "" "--without-nvtt")
+		$(usex pch "" "--without-pch")
+		$(usex test "" "--without-tests")
+		$(usex editor "--atlas" "")
+		$(usex lobby "" "--without-lobby")
+		--bindir="/usr/bin"
+		--libdir="/usr/$(get_libdir)"/${PN}
+		--datadir="/usr/share/${PN}"
+	)
+
+	tc-export AR CC CXX RANLIB
+
+	local mypremakeargs=(
+		--outpath="../workspace/gcc"
+		--os=linux
+		--verbose
+	)
+
+	cd "${S}/build/premake" || die "Could not enter premake directory"
+
+	/usr/bin/premake5 "${mypremakeargs[@]}" "${myconf[@]}" gmake2 \
+		|| die "Premake failed"
+}
+
+src_compile() {
+	# Build 3rd party fcollada
+	einfo "Building bundled fcollada"
+	emake -C libraries/source/fcollada/src
+
+	# Build bundled NVTT
+	# nvtt is abandoned upstream and 0ad has forked it and added fixes.
+	# Use their copy. bug #768930
+	if use nvtt ; then
+		cd libraries/source/nvtt || die
+		elog "Building bundled NVTT (bug #768930)"
+		JOBS="-j$(makeopts_jobs)" ./build.sh || die "Failed to build bundled NVTT"
+		cd "${S}" || die
+	fi
+
+	# Build bundled SpiderMonkey
+	# We really can't use the system SpiderMonkey right now.
+	# Breakages occur even on minor bumps in upstream SM,
+	# e.g. bug #768840.
+	cd libraries/source/spidermonkey || die
+	elog "Building bundled SpiderMonkey (bug #768840)"
+	XARGS="${EPREFIX}/usr/bin/xargs" \
+		JOBS="-j$(makeopts_jobs)" \
+		./build.sh \
+	|| die "Failed to build bundled SpiderMonkey"
+
+	cd "${S}" || die
+
+	# Build 0ad itself!
+	elog "Building 0ad"
+	JOBS="-j$(makeopts_jobs)" emake -C build/workspace/gcc verbose=1
+
+	# Build assets
+	# (We only do this if we're using a snapshot/non-release)
+	# See bug #771147 (comment 3) and the old 0ad-data ebuild
+	# Warning: fragile!
+	if [[ ${PV} == 9999 || ${PV} == *_pre* ]]; then
+		# source/lib/sysdep/os/linux/ldbg.cpp:debug_SetThreadName() tries to open /proc/self/task/${TID}/comm for writing.
+		addpredict /proc/self/task
+
+		# Based on source/tools/dist/build-archives.sh used by source/tools/dist/build.sh.
+		local archivebuild_input archivebuild_output mod_name
+		for archivebuild_input in binaries/data/mods/[A-Za-z0-9]*; do
+			mod_name="${archivebuild_input##*/}"
+			archivebuild_output="archives/${mod_name}"
+
+			mkdir -p "${archivebuild_output}" || die
+
+			einfo pyrogenesis -archivebuild="${archivebuild_input}" -archivebuild-output="${archivebuild_output}/${mod_name}.zip"
+			LD_LIBRARY_PATH="binaries/system" binaries/system/pyrogenesis \
+				-archivebuild="${archivebuild_input}" \
+				-archivebuild-output="${archivebuild_output}/${mod_name}.zip" \
+			|| die "Failed to build assets"
+
+			if [[ -f "${archivebuild_input}/mod.json" ]]; then
+				cp "${archivebuild_input}/mod.json" "${archivebuild_output}" || die
+			fi
+
+			rm -r "${archivebuild_input}" || die
+			mv "${archivebuild_output}" "${archivebuild_input}" || die
+		done
+
+		# Based on source/tools/dist/build-unix-win32.sh used by source/tools/dist/build.sh.
+		rm binaries/data/config/dev.cfg || die
+		rm -r binaries/data/mods/_test.* || die
+	fi
+}
+
+src_test() {
+	cd binaries/system || die
+	./test -libdir "${S}/binaries/system" || die "Failed tests"
+}
+
+src_install() {
+	newbin binaries/system/pyrogenesis 0ad
+	use editor && newbin binaries/system/ActorEditor 0ad-ActorEditor
+
+	# Merged from 0ad-data
+	# bug #771147 (comment 3)
+	insinto /usr/share/${PN}
+	doins -r binaries/data/{l10n,config,mods,tools}
+
+	# Install bundled SpiderMonkey and nvtt
+	# bug #771147 (comment 1)
+	exeinto /usr/$(get_libdir)/${PN}
+	doexe binaries/system/{libCollada,libmozjs78-ps-release}.so
+
+	use nvtt && doexe binaries/system/{libnvtt,libnvcore,libnvimage,libnvmath}.so
+	use editor && doexe binaries/system/libAtlasUI.so
+
+	dodoc binaries/system/readme.txt
+	doicon -s 128 build/resources/${PN}.png
+	make_desktop_entry ${PN}
+}

diff --git a/games-strategy/0ad/Manifest b/games-strategy/0ad/Manifest
index 5d2ea27d724..42d9a470983 100644
--- a/games-strategy/0ad/Manifest
+++ b/games-strategy/0ad/Manifest
@@ -1,3 +1,5 @@
 DIST 0ad-0.0.24_alpha_pre20210116040036.tar.gz 2562395684 BLAKE2B 03d6655f7aa1f2f91a87536a7f2afa465585856c4209ddc05e666e1e5596416883596331118ac4257ff314b04d8a5c08821eaa6ae76e5d3095146ab04f8c79ed SHA512 e1239a56b184a87708c87fc03ca41190a16d813e495c5d81ee073df98761f1524a23902e5d03a21a1b1f657b496fce6eeee4a5ef22eee30f70fbe3b0dbd44510
 DIST 0ad-0.0.24b-alpha-unix-build.tar.xz 75546740 BLAKE2B a724abba6bed4b580670588e9dcfe0f75f6cef0fbde6ad666356e96213c685932edd0a1daafb5dd04206870c2c8222340c9c51e83076ec2911cbb5377ca00666 SHA512 8173d393eb1bc57c38bef0076ba973ef46c877c06644365189c0887cd3152adba51d26b553e42221fd14343e9830a3a275bfcd9b28f66281e282ea3f247730ea
 DIST 0ad-0.0.24b-alpha-unix-data.tar.xz 828553992 BLAKE2B 2081225d88d475ed0899648994a900677bc3280bb2ba6cf92354ece82b90ddcefddb48458fa23e2de97100e58f4db8db408d4b50d0306a8c3efe47d263064bf0 SHA512 d7804d25ddf376028f230a31c6fc1201dfa366b3d5434569a1a7852bb4c400fb14e5c8934c5d6c6295320cf2e62c64be83b1e3c4c27fd116115bfe7d01106726
+DIST 0ad-0.0.25-alpha-unix-build.tar.xz 75788348 BLAKE2B 49b8b99a8f2fd33d4a3c2c0320375cb372d23b2f2c0f4ba56438bc8d868891c8c8c624049e3165ec84f8b98bcb1e1195b672aa7ee258ff88317af9d4da883576 SHA512 a8edae7d2dd61972b947152edda8d9ca8bafd3d435623a94de2d1297ecad3bfc73d3b30eaff98e89a6bcb0291b49f1e25bae1300fde37c8989156c895cd12730
+DIST 0ad-0.0.25-alpha-unix-data.tar.xz 1272283892 BLAKE2B 7bc08e52b44129fce6a78914d36bcb0c8bb3312645982054274e230a23edc34f9aa899d7ca8f52f3044b8c7efd0aea4b5d16fcd9d6e20e274538007885cfa1c2 SHA512 92fad341ceb1156a3facea291856ca2f719691bba1cf085de0544f3ae9300f46391efdd1c88bcf1aafd9a9c938b6bef3babbd50c850dc17fb0c9609dbabe37ad


             reply	other threads:[~2021-08-15 21:33 UTC|newest]

Thread overview: 49+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2021-08-15 20:57 Sam James [this message]
  -- strict thread matches above, loose matches on Subject: below --
2023-11-22 15:01 [gentoo-commits] repo/gentoo:master commit in: games-strategy/0ad/ Andrew Ammerlaan
2023-09-14  3:41 Sam James
2022-08-11  7:37 Ionen Wolkens
2022-06-10  8:36 Sam James
2021-12-14  9:04 Sam James
2021-08-28  3:39 Sam James
2021-08-28  3:39 Sam James
2021-08-28  3:39 Sam James
2021-08-28  3:39 Sam James
2021-08-15 20:57 Sam James
2021-06-17 23:24 Sam James
2021-05-28 19:26 Sam James
2021-03-04  5:03 Sam James
2021-03-01 19:44 Sam James
2021-03-01 19:06 Sam James
2021-03-01 13:45 Sam James
2021-03-01 10:56 Sam James
2021-03-01 10:20 Sam James
2021-03-01 10:16 Sam James
2021-02-28 23:20 Sam James
2021-02-28 23:18 Sam James
2021-02-28 23:04 Sam James
2021-02-28 23:04 Sam James
2021-02-28 23:04 Sam James
2021-02-28 23:04 Sam James
2021-02-28 23:04 Sam James
2021-02-28 23:04 Sam James
2021-02-28 23:04 Sam James
2021-02-28 23:04 Sam James
2021-02-28 23:04 Sam James
2021-02-12 20:18 Sam James
2021-01-17  1:17 Sam James
2020-09-05  0:35 Sam James
2018-12-25 23:40 Lars Wendler
2018-10-31  8:29 Lars Wendler
2018-05-24 21:19 Maciej Mrozowski
2018-05-24 14:39 Lars Wendler
2018-01-05 13:01 Lars Wendler
2017-08-22  7:14 Lars Wendler
2017-08-04  8:44 Lars Wendler
2017-07-27 13:38 Lars Wendler
2017-06-12  8:10 Michael Palimaka
2016-09-29  5:40 Lars Wendler
2015-10-26 18:00 Julian Ospald
2015-10-26 18:00 Julian Ospald
2015-10-26 17:32 Julian Ospald
2015-09-15 23:56 Julian Ospald
2015-08-20 22:31 Julian Ospald

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1629061016.57cc262249976487a77241a6641f6c9437072b69.sam@gentoo \
    --to=sam@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox